SystemOrganization addCategory: #BattleShip!

Object subclass: #Cell
	instanceVariableNames: 'isHit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

Cell subclass: #BigCaptainCell
	instanceVariableNames: 'ship noOfHits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:54'!
getCharStatus
	super isHit
		ifTrue: [ 
			noOfHits = 1
				ifTrue: [ ^ 'x' ].
			noOfHits > 1
				ifTrue: [ ^ '@' ] ].
	^ '~'! !

!BigCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:31'!
hit
	noOfHits = 0
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			super hit.
			^ 'Miss' ].
	noOfHits = 1
		ifTrue: [ 
			noOfHits := noOfHits + 1.
			ship destroy.
			^ 'Sunk' , ship toString ].
	noOfHits := noOfHits + 1.
	^ 'Miss'! !

!BigCaptainCell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 17:29'!
initialize
	noOfHits := 0! !

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:50'!
isHit
	noOfHits > 1
		ifTrue: [ ^ true ].
	^ false! !

!BigCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:49'!
isOccupied
	^true! !

!BigCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:40'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

!Cell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:20'!
getCharStatus
	self subclassResponsibility ! !

!Cell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:17'!
hit
	isHit := true.
	^''! !

!Cell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 17:28'!
initialize 
	isHit := false! !

!Cell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:18'!
isHit
	^isHit! !

!Cell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:19'!
isOccupied
	self subclassResponsibility ! !

Cell subclass: #ShipCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:34'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ]
		ifFalse: [ ^ '~' ]! !

!ShipCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:29'!
hit
	self isHit
		ifTrue: [ ^ 'Miss' ]
		ifFalse: [ 
			super hit.
			^ 'Hit' ]! !

!ShipCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:29'!
isOccupied
	^true! !

!ShipCell methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 16:25'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #SmallCaptainCell
	instanceVariableNames: 'ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:00'!
getCharStatus
	self isHit
		ifTrue: [ ^ '@' ].
	^ '~'! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:33'!
hit
	self isHit
		ifFalse: [ 
			super hit.
			ship destroy.
			^ 'Sunk', ship toString ].
	^ 'Miss'! !

!SmallCaptainCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 16:59'!
isOccupied
	^true! !

!SmallCaptainCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 16:56'!
ship: aShip
	ship := aShip.
	ship addCell: self! !

Cell subclass: #WaterCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!WaterCell methodsFor: 'accessing' stamp: 'YuLin 5/2/2013 17:03'!
getCharStatus
	self isHit ifTrue: [ ^'x' ].
	^'~'! !

!WaterCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:02'!
hit 
	^'Miss'! !

!WaterCell methodsFor: 'testing' stamp: 'YuLin 5/2/2013 17:02'!
isOccupied 
	^false! !

Object subclass: #Grid
	instanceVariableNames: 'gridHeight gridWidth cells nrOfavailableShips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Grid methodsFor: 'update' stamp: 'YuLin 5/2/2013 18:56'!
addShip: aShip atX: x atY: y
	cells := aShip occupyCells: cells atX: x atY: y.
	nrOfavailableShips := nrOfavailableShips + 1.
	aShip subscribe: self! !

!Grid methodsFor: 'initialize-release' stamp: 'YuLin 5/2/2013 19:36'!
height: aHeight width: aWidth
	| index |
	index := 1.
	gridHeight := aHeight.
	gridWidth := aWidth.
	nrOfavailableShips := 0.
	cells := Array new: aHeight.
	[ index <= aHeight ]
		whileTrue: [ 
			cells at: index put: (Array new: aWidth).
			index := index + 1 ].
	cells
		do: [ :row | 
			index := 1.
			[ index <= aWidth ]
				whileTrue: [ 
					row at: index put: WaterCell new.
					index := index + 1 ] ]! !

!Grid methodsFor: 'update' stamp: 'YuLin 5/2/2013 19:21'!
hitX: x hitY: y
	| result |
	result := ((cells at: x) at: y) hit.
	nrOfavailableShips = 0
		ifTrue: [ result := 'Surrender' ].
	^ result! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 19:38'!
peekGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Array new: gridHeight.
	[ i <= gridHeight ]
		whileTrue: [ 
			toReturn at: i put: (Array new: gridWidth).
			i := i + 1 ].
	i := 1.
	toReturn
		do: [ :row | 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := (cells at: i) at: j.
					row at: j put: (cell getCharStatus).
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

!Grid methodsFor: 'print' stamp: 'YuLin 5/2/2013 19:38'!
peekMyGridToGui
	| toReturn i j cell |
	i := 1.
	toReturn := Array new: gridHeight.
	[ i <= gridHeight ]
		whileTrue: [ 
			toReturn at: i put: (Array new: gridWidth).
			i := i + 1 ].
	i := 1.
	toReturn
		do: [ :row | 
			j := 1.
			[ j <= gridWidth ]
				whileTrue: [ 
					cell := (cells at: i) at: j.
					row at: j put: '~'.
					cell isOccupied
						ifTrue: [ row at: j put: 'B' ].
					j := j + 1 ].
			i := i + 1 ].
	^ toReturn! !

Object subclass: #Layout
	instanceVariableNames: 'isRotate layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Layout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:24'!
withLayout: aLayout 
	layout = self new.
	layout layout: aLayout .! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:29'!
getCells
	self subclassResponsibility! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:28'!
layout
	^layout.! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:15'!
layout: aLayout 	
 layout := aLayout .! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:27'!
rotate! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:27'!
rotateCCW! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:27'!
rotateCW! !

!Layout methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:15'!
withLayout: aLayout	
	layout := aLayout.! !

Layout subclass: #ShipLayout
	instanceVariableNames: 'cellTypes ship'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:36'!
checkCollisionAtX: x andY: y forCells: cells! !

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:37'!
getCellTypeAt: index! !

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:35'!
getCells! !

!ShipLayout class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:34'!
withLayout: aLayout forShip: aShip
	layout := self withLayout: aLayout.
	layout ship: aShip.! !

Object subclass: #Ship
	instanceVariableNames: 'name cells shipLayout destroyed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip'!

!Ship class methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 18:58'!
named: aName withLayout: aLayout
	Ship new named: aName withLayout: aLayout.! !

!Ship methodsFor: 'adding' stamp: 'MihaiCodoban 5/2/2013 19:01'!
addCell: aCell
	cells add: aCell.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:03'!
destroy
	cells do: [ :eachCell | eachCell hit  ].
	"notify observers"! !

!Ship methodsFor: 'accessing' stamp: 'MihaiCodoban 5/2/2013 19:05'!
name
 ^name.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 18:59'!
named: aName withLayout: aLayout
	name := aName.
	shipLayout := ShipLayout withLayout: aLayout ForShip: self.
	cells := OrderedCollection new.! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/2/2013 19:32'!
occupyCells: cells atX: x atY: y
	^cells! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:06'!
rotate! !

!Ship methodsFor: 'as yet unclassified' stamp: 'YuLin 5/2/2013 19:24'!
subscribe: grid! !

!Ship methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/2/2013 19:06'!
toString
	name! !
